{ --------------------------------------------------------------- //}
{ A public domain demo of "movie" type scrolling,	courtesy of		//}
{ Kenneth A. Long (kenlong@netcom.com).							//}
{ An itty bitty bytes production, for the benefit of anyone		//}
{ who can use it.													//}
{ This is basically just "Bullseye" with some things dumped and	//}
{ two routines added, and a resource file to back the additions.	//}

{ If you want the text drawn over black, like in the movies, 		//}
{ then some other "girations" are necessary.  This just shows 	//}
{ the scrolling, with style.										//}

{ Enjoy!															//}

{ --------------------------------------------------------------- //}

{Revised by Ingemar Ragnemalm:}
{- Took out event handling - the modal dialog is just enough for the demo}
{- Converted to Pascal}
{- Timed the scrolling with TickCount, so it won't get ridiculously slow}
{or, for that matter, fast.}
{Slight revision nov-95:}
{- Universal Interfaces}
{- PPC project}

program MovieScroll;

{$IFC UNDEFINED THINK_PASCAL}
	uses
		Types, Quickdraw, Dialogs, Windows, Menus, Fonts, Events,{}
		ToolUtils, TextEdit, Resources;
{$ELSEC}
{$SETC GENERATINGPOWERPC := false}
{$ENDC}

	var
		textHand: TEHandle;
		appleMenu, fileMenu: MenuHandle;
		shell_window: WindowPtr;

	const
		aboutID = 128;

		appleID = 1;
		fileID = 2;
		quitItem = 1;

{In case you don't use Universal Interfaces with Think P, here's the renamed routines:}
{$IFC UNDEFINED THINK_PASCAL}
{$ELSEC}
	type
		DialogRef = DialogPtr;
	procedure GetDialogItem (theDialog: DialogRef; itemNo: INTEGER; var itemType: INTEGER; var item: Handle; var box: Rect);
	inline
		$A98D;
	procedure SetDialogItem (theDialog: DialogRef; itemNo: INTEGER; itemType: INTEGER; item: Handle; {CONST}
									var box: Rect);
	inline
		$A98E;
	function TEStyleNew ({CONST}
									var destRect: Rect; {CONST}
									var viewRect: Rect): TEHandle;
	inline
		$A83E;
	procedure TEStyleInsert (text: univ Ptr; length: LONGINT; hST: StScrpHandle; hTE: TEHandle);
	inline
		$3F3C, $0007, $A83D;
	function GetResourceSizeOnDisk (theResource: Handle): LONGINT;
	inline
		$A9A5;
	procedure TESetAlignment (just: INTEGER; hTE: TEHandle);
	inline
		$A9DF;
{$ENDC}

	procedure InitMacintosh;
	begin
{$IFC UNDEFINED THINK_PASCAL}
		InitGraf(@qd.thePort);
		InitFonts;
		InitWindows;
		InitMenus;
		TEInit;
		InitDialogs(nil);
		MaxApplZone;
{$ENDC}
		FlushEvents(everyEvent, 0);
		InitCursor;
	end;

	procedure OutlineDefault (myDialog: WindowPtr; itemNo: Integer);
		var
			x: Integer;
			rectangle: Rect;
			theHandle: Handle;
	begin
		GetDialogItem(DialogPtr(myDialog), itemNo, x, theHandle, rectangle);
		PenSize(3, 3);
		InsetRect(rectangle, -4, -4);
		FrameRoundRect(rectangle, 16, 16);
		PenSize(1, 1);
	end;

	const
		SCREEN = 2;					{ Text window useritem.}
		SHOWTIME = 3;

		USERITEM = 7;				{ Used to outline default button.}
		textID = 128;				{ rsrc ID# for text used.}
		styleID = 128;				{ rsrc ID# for styl used.}
		kTicksPerStep = 2;			{Number of ticks per step}
	var
		saveWPtr: GrafPtr;			{ Holds previous grafPtr.}
		aboutPtr: DialogPtr;		{ Pointer to dialog.}
		theItem: Integer;			{ Item selected by user.}
		mLoc: Point;				{ Mouse location.}
		rectangle: Rect;
		x: Integer;
		theHandle: Handle;
		txtRect: Rect;				{ Used to hold viewRect.}
		saveTxtHdl: TEHandle;		{ Text handle.}
		finished: Boolean;			{ Pushed 'The End' button yet?}
		styleHdl: StScrpHandle;
		err: OSErr;

		thisTime, lastTime: Longint;
{$IFC GENERATINGPOWERPC }
		drawProc: ProcPtr;
{$ENDC}

begin
	InitMacintosh;

	GetPort(saveWPtr);				{ Save the old port.}
	saveTxtHdl := textHand;			{ Save the old text hdl.}

	{ Get dialog box pointer.}
	aboutPtr := GetNewDialog(aboutID, nil, WindowPtr(-1));

	{ This next makes the static text field font monaco 9.}
	SetPort(GrafPtr(aboutPtr));	{ Output to dialog.}
	TextSize(9);					{ Set text size.}
	TextFont(monaco);				{ Set text font.}

	{ Get text window rect.}
	GetDialogItem(DialogPtr(aboutPtr), SCREEN, x, theHandle, txtRect);
	InsetRect(txtRect, 5, 1);		{ Leave margins for text.}

	{ Create styled TERecord.}
	textHand := TEStyleNew(txtRect, txtRect);

	{ Read the TEXT resource.}
	theHandle := GetResource('TEXT', textID);
	HLock(theHandle);					{ Lock handle.}

	{ Get the style handle.}
	styleHdl := StScrpHandle(Get1Resource('styl', styleID));
	TEStyleInsert(theHandle^, GetResourceSizeOnDisk(theHandle), styleHdl, textHand);	{ move text into text record.}
	TESetAlignment(1, textHand);
	HUnlock(theHandle);					{ Unlock handle.}

	ShowWindow(aboutPtr);				{ Show dialog box now.}
	TEUpdate(txtRect, textHand);		{ Draw text in viewRect.}
	InsetRect(txtRect, -5, -1);		{ Leave margins for text.}
	FrameRect(txtRect);				{ Draw frame around text.}
	OutlineDefault(aboutPtr, USERITEM);
	GetDialogItem(DialogPtr(aboutPtr), USERITEM, x, theHandle, rectangle);	{ outline default button.}
{$IFC GENERATINGPOWERPC}
	drawProc := NewRoutineDescriptor(@OutlineDefault, uppUserItemProcInfo, GetCurrentISA);
	SetDialogItem(aboutPtr, USERITEM, x, Handle(drawProc), rectangle);	{ redraw if erased*/}
{$ELSEC}
	SetDialogItem(aboutPtr, USERITEM, x, Handle(@OutlineDefault), rectangle);	{ redraw if erased*/}
{$ENDC}

	finished := false;				{ Reset flag.}
	repeat 							{ Repeat until finished.}
		ModalDialog(nil, theItem);	{ Show dialog/get result.}
		case theItem of 			{ Control hit.}
			OK: 
				finished := true;	{ "The End" button hit / close.}
			SHOWTIME: 
				begin
					thisTime := TickCount div kTicksPerStep;
					repeat
						lastTime := TickCount div kTicksPerStep;
					{ scroll up a pixel}
						TEScroll(0, thisTime - TickCount div kTicksPerStep, textHand);
						thisTime := lastTime;
					until Button;
				end;
			otherwise
		end;							{ End of  case.}
	until finished;			{ End of  mainloop.}

	TEDispose(textHand);			{ Reclaim heap space.}
	textHand := saveTxtHdl;			{ Restore global textHand.}
	DisposeDialog(aboutPtr);			{ Get rid of dialog box.}
	SetPort(saveWPtr);				{ Restore the old port.}
end.